/*
 * clone.c
 *
 * This file was automatically generated. Do not edit!
 */

#include "clone.h"

/*
 * the _copy methods free any existing data in dst
 * for _dup methods, any existing data in dst will be lost
 */


void
EventData_dup(EventData *dst, EventData *src)
{
	
      
	/* CHOICE */
	dst->choice = src->choice;

	switch(src->choice)
	{
	
	case EventData_boolean:
		dst->u.boolean = src->u.boolean;
		break;
		
	case EventData_integer:
		dst->u.integer = src->u.integer;
		break;
		
	case EventData_octetstring:
		OctetString_dup(&dst->u.octetstring, &src->u.octetstring);
		break;
		
	default:
		error("Unknown EventData type: %d", src->choice);
		break;
	}

   
	return;
}

void
EventData_copy(EventData *dst, EventData *src)
{
	free_EventData(dst);

	EventData_dup(dst, src);

	return;
}

void
ObjectReference_dup(ObjectReference *dst, ObjectReference *src)
{
	
      
	/* CHOICE */
	dst->choice = src->choice;

	switch(src->choice)
	{
	
	case ObjectReference_internal_reference:
		dst->u.internal_reference = src->u.internal_reference;
		break;
		
	case ObjectReference_external_reference:
		ExternalReference_dup(&dst->u.external_reference, &src->u.external_reference);
		break;
		
	default:
		error("Unknown ObjectReference type: %d", src->choice);
		break;
	}

   
	return;
}

void
ObjectReference_copy(ObjectReference *dst, ObjectReference *src)
{
	free_ObjectReference(dst);

	ObjectReference_dup(dst, src);

	return;
}

void
ExternalReference_dup(ExternalReference *dst, ExternalReference *src)
{
	
      
	/* SEQUENCE */
	
	/* not OPTIONAL */
	OctetString_dup(&dst->group_identifier, &src->group_identifier);
				
	/* not OPTIONAL */
	dst->object_number = src->object_number;
				
   
	return;
}

void
ExternalReference_copy(ExternalReference *dst, ExternalReference *src)
{
	free_ExternalReference(dst);

	ExternalReference_dup(dst, src);

	return;
}

void
ContentReference_dup(ContentReference *dst, ContentReference *src)
{
	
      
	OctetString_dup(dst, src);
		
   
	return;
}

void
ContentReference_copy(ContentReference *dst, ContentReference *src)
{
	free_ContentReference(dst);

	ContentReference_dup(dst, src);

	return;
}

void
OriginalValue_dup(OriginalValue *dst, OriginalValue *src)
{
	
      
	/* CHOICE */
	dst->choice = src->choice;

	switch(src->choice)
	{
	
	case OriginalValue_boolean:
		dst->u.boolean = src->u.boolean;
		break;
		
	case OriginalValue_integer:
		dst->u.integer = src->u.integer;
		break;
		
	case OriginalValue_octetstring:
		OctetString_dup(&dst->u.octetstring, &src->u.octetstring);
		break;
		
	case OriginalValue_object_reference:
		ObjectReference_dup(&dst->u.object_reference, &src->u.object_reference);
		break;
		
	case OriginalValue_content_reference:
		ContentReference_dup(&dst->u.content_reference, &src->u.content_reference);
		break;
		
	default:
		error("Unknown OriginalValue type: %d", src->choice);
		break;
	}

   
	return;
}

void
OriginalValue_copy(OriginalValue *dst, OriginalValue *src)
{
	free_OriginalValue(dst);

	OriginalValue_dup(dst, src);

	return;
}

void
RectangleClass_dup(RectangleClass *dst, RectangleClass *src)
{
	
      
         LineArtClass_dup(dst, src);
		
      
   
	return;
}

void
RectangleClass_copy(RectangleClass *dst, RectangleClass *src)
{
	free_RectangleClass(dst);

	RectangleClass_dup(dst, src);

	return;
}

void
LineArtClass_dup(LineArtClass *dst, LineArtClass *src)
{
	
      
	/* SEQUENCE */
	
	/* not OPTIONAL */
	RootClass_dup(&dst->rootClass, &src->rootClass);
				
	/* not OPTIONAL */
	dst->initially_active = src->initially_active;
				
	dst->have_content_hook = src->have_content_hook;
	if(src->have_content_hook)
		dst->content_hook = src->content_hook;
				
	dst->have_original_content = src->have_original_content;
	if(src->have_original_content)
		ContentBody_dup(&dst->original_content, &src->original_content);
				
	dst->have_shared = src->have_shared;
	if(src->have_shared)
		dst->shared = src->shared;
				
	/* not OPTIONAL */
	OriginalBoxSize_dup(&dst->original_box_size, &src->original_box_size);
				
	/* not OPTIONAL */
	XYPosition_dup(&dst->original_position, &src->original_position);
				
	dst->have_original_palette_ref = src->have_original_palette_ref;
	if(src->have_original_palette_ref)
		ObjectReference_dup(&dst->original_palette_ref, &src->original_palette_ref);
				
	dst->have_bordered_bounding_box = src->have_bordered_bounding_box;
	if(src->have_bordered_bounding_box)
		dst->bordered_bounding_box = src->bordered_bounding_box;
				
	/* not OPTIONAL */
	dst->original_line_width = src->original_line_width;
				
	/* not OPTIONAL */
	dst->original_line_style = src->original_line_style;
				
	dst->have_original_ref_line_colour = src->have_original_ref_line_colour;
	if(src->have_original_ref_line_colour)
		Colour_dup(&dst->original_ref_line_colour, &src->original_ref_line_colour);
				
	dst->have_original_ref_fill_colour = src->have_original_ref_fill_colour;
	if(src->have_original_ref_fill_colour)
		Colour_dup(&dst->original_ref_fill_colour, &src->original_ref_fill_colour);
				
   
	return;
}

void
LineArtClass_copy(LineArtClass *dst, LineArtClass *src)
{
	free_LineArtClass(dst);

	LineArtClass_dup(dst, src);

	return;
}

void
ContentBody_dup(ContentBody *dst, ContentBody *src)
{
	
      
	/* CHOICE */
	dst->choice = src->choice;

	switch(src->choice)
	{
	
	case ContentBody_included_content:
		OctetString_dup(&dst->u.included_content, &src->u.included_content);
		break;
		
	case ContentBody_referenced_content:
		ReferencedContent_dup(&dst->u.referenced_content, &src->u.referenced_content);
		break;
		
	default:
		error("Unknown ContentBody type: %d", src->choice);
		break;
	}

   
	return;
}

void
ContentBody_copy(ContentBody *dst, ContentBody *src)
{
	free_ContentBody(dst);

	ContentBody_dup(dst, src);

	return;
}

void
ReferencedContent_dup(ReferencedContent *dst, ReferencedContent *src)
{
	
      
	/* SEQUENCE */
	
	/* not OPTIONAL */
	ContentReference_dup(&dst->content_reference, &src->content_reference);
				
	dst->have_content_size = src->have_content_size;
	if(src->have_content_size)
		dst->content_size = src->content_size;
				
	/* not OPTIONAL */
	dst->content_cache_priority = src->content_cache_priority;
				
   
	return;
}

void
ReferencedContent_copy(ReferencedContent *dst, ReferencedContent *src)
{
	free_ReferencedContent(dst);

	ReferencedContent_dup(dst, src);

	return;
}

void
OriginalBoxSize_dup(OriginalBoxSize *dst, OriginalBoxSize *src)
{
	
      
	/* SEQUENCE */
	
	/* not OPTIONAL */
	dst->x_length = src->x_length;
				
	/* not OPTIONAL */
	dst->y_length = src->y_length;
				
   
	return;
}

void
OriginalBoxSize_copy(OriginalBoxSize *dst, OriginalBoxSize *src)
{
	free_OriginalBoxSize(dst);

	OriginalBoxSize_dup(dst, src);

	return;
}

void
XYPosition_dup(XYPosition *dst, XYPosition *src)
{
	
      
	/* SEQUENCE */
	
	/* not OPTIONAL */
	dst->x_position = src->x_position;
				
	/* not OPTIONAL */
	dst->y_position = src->y_position;
				
   
	return;
}

void
XYPosition_copy(XYPosition *dst, XYPosition *src)
{
	free_XYPosition(dst);

	XYPosition_dup(dst, src);

	return;
}

void
Colour_dup(Colour *dst, Colour *src)
{
	
      
	/* CHOICE */
	dst->choice = src->choice;

	switch(src->choice)
	{
	
	case Colour_colour_index:
		dst->u.colour_index = src->u.colour_index;
		break;
		
	case Colour_absolute_colour:
		OctetString_dup(&dst->u.absolute_colour, &src->u.absolute_colour);
		break;
		
	default:
		error("Unknown Colour type: %d", src->choice);
		break;
	}

   
	return;
}

void
Colour_copy(Colour *dst, Colour *src)
{
	free_Colour(dst);

	Colour_dup(dst, src);

	return;
}

void
BitmapClass_dup(BitmapClass *dst, BitmapClass *src)
{
	
      
	/* SEQUENCE */
	
	/* not OPTIONAL */
	RootClass_dup(&dst->rootClass, &src->rootClass);
				
	/* not OPTIONAL */
	dst->initially_active = src->initially_active;
				
	dst->have_content_hook = src->have_content_hook;
	if(src->have_content_hook)
		dst->content_hook = src->content_hook;
				
	dst->have_original_content = src->have_original_content;
	if(src->have_original_content)
		ContentBody_dup(&dst->original_content, &src->original_content);
				
	dst->have_shared = src->have_shared;
	if(src->have_shared)
		dst->shared = src->shared;
				
	/* not OPTIONAL */
	OriginalBoxSize_dup(&dst->original_box_size, &src->original_box_size);
				
	/* not OPTIONAL */
	XYPosition_dup(&dst->original_position, &src->original_position);
				
	dst->have_original_palette_ref = src->have_original_palette_ref;
	if(src->have_original_palette_ref)
		ObjectReference_dup(&dst->original_palette_ref, &src->original_palette_ref);
				
	/* not OPTIONAL */
	dst->tiling = src->tiling;
				
	/* not OPTIONAL */
	dst->original_transparency = src->original_transparency;
				
   
	return;
}

void
BitmapClass_copy(BitmapClass *dst, BitmapClass *src)
{
	free_BitmapClass(dst);

	BitmapClass_dup(dst, src);

	return;
}

void
TextClass_dup(TextClass *dst, TextClass *src)
{
	
      
	/* SEQUENCE */
	
	/* not OPTIONAL */
	RootClass_dup(&dst->rootClass, &src->rootClass);
				
	dst->have_character_set = src->have_character_set;
	if(src->have_character_set)
		dst->character_set = src->character_set;
				
	dst->have_background_colour = src->have_background_colour;
	if(src->have_background_colour)
		Colour_dup(&dst->background_colour, &src->background_colour);
				
	dst->have_text_colour = src->have_text_colour;
	if(src->have_text_colour)
		Colour_dup(&dst->text_colour, &src->text_colour);
				
	dst->have_font_attributes = src->have_font_attributes;
	if(src->have_font_attributes)
		OctetString_dup(&dst->font_attributes, &src->font_attributes);
				
	/* not OPTIONAL */
	dst->initially_active = src->initially_active;
				
	dst->have_content_hook = src->have_content_hook;
	if(src->have_content_hook)
		dst->content_hook = src->content_hook;
				
	dst->have_original_content = src->have_original_content;
	if(src->have_original_content)
		ContentBody_dup(&dst->original_content, &src->original_content);
				
	dst->have_shared = src->have_shared;
	if(src->have_shared)
		dst->shared = src->shared;
				
	/* not OPTIONAL */
	OriginalBoxSize_dup(&dst->original_box_size, &src->original_box_size);
				
	/* not OPTIONAL */
	XYPosition_dup(&dst->original_position, &src->original_position);
				
	dst->have_original_palette_ref = src->have_original_palette_ref;
	if(src->have_original_palette_ref)
		ObjectReference_dup(&dst->original_palette_ref, &src->original_palette_ref);
				
	dst->have_original_font = src->have_original_font;
	if(src->have_original_font)
		FontBody_dup(&dst->original_font, &src->original_font);
				
	/* not OPTIONAL */
	Justification_dup(&dst->horizontal_justification, &src->horizontal_justification);
				
	/* not OPTIONAL */
	Justification_dup(&dst->vertical_justification, &src->vertical_justification);
				
	/* not OPTIONAL */
	LineOrientation_dup(&dst->line_orientation, &src->line_orientation);
				
	/* not OPTIONAL */
	StartCorner_dup(&dst->start_corner, &src->start_corner);
				
	/* not OPTIONAL */
	dst->text_wrapping = src->text_wrapping;
				
   
	return;
}

void
TextClass_copy(TextClass *dst, TextClass *src)
{
	free_TextClass(dst);

	TextClass_dup(dst, src);

	return;
}

void
FontBody_dup(FontBody *dst, FontBody *src)
{
	
      
	/* CHOICE */
	dst->choice = src->choice;

	switch(src->choice)
	{
	
	case FontBody_indirect_font:
		ObjectReference_dup(&dst->u.indirect_font, &src->u.indirect_font);
		break;
		
	case FontBody_direct_font:
		OctetString_dup(&dst->u.direct_font, &src->u.direct_font);
		break;
		
	default:
		error("Unknown FontBody type: %d", src->choice);
		break;
	}

   
	return;
}

void
FontBody_copy(FontBody *dst, FontBody *src)
{
	free_FontBody(dst);

	FontBody_dup(dst, src);

	return;
}

void
Justification_dup(Justification *dst, Justification *src)
{
	
      
	*dst = *src;
		
   
	return;
}

void
Justification_copy(Justification *dst, Justification *src)
{
	free_Justification(dst);

	Justification_dup(dst, src);

	return;
}

void
LineOrientation_dup(LineOrientation *dst, LineOrientation *src)
{
	
      
	*dst = *src;
		
   
	return;
}

void
LineOrientation_copy(LineOrientation *dst, LineOrientation *src)
{
	free_LineOrientation(dst);

	LineOrientation_dup(dst, src);

	return;
}

void
StartCorner_dup(StartCorner *dst, StartCorner *src)
{
	
      
	*dst = *src;
		
   
	return;
}

void
StartCorner_copy(StartCorner *dst, StartCorner *src)
{
	free_StartCorner(dst);

	StartCorner_dup(dst, src);

	return;
}

void
VariableClass_dup(VariableClass *dst, VariableClass *src)
{
	
      
	/* SEQUENCE */
	
	/* not OPTIONAL */
	RootClass_dup(&dst->rootClass, &src->rootClass);
				
	/* not OPTIONAL */
	dst->initially_active = src->initially_active;
				
	dst->have_content_hook = src->have_content_hook;
	if(src->have_content_hook)
		dst->content_hook = src->content_hook;
				
	dst->have_original_content = src->have_original_content;
	if(src->have_original_content)
		ContentBody_dup(&dst->original_content, &src->original_content);
				
	dst->have_shared = src->have_shared;
	if(src->have_shared)
		dst->shared = src->shared;
				
	/* not OPTIONAL */
	OriginalValue_dup(&dst->original_value, &src->original_value);
				
   
	return;
}

void
VariableClass_copy(VariableClass *dst, VariableClass *src)
{
	free_VariableClass(dst);

	VariableClass_dup(dst, src);

	return;
}
